/*@
  theory uses Base
  {
    isPermutation: PREDICATE(Base.IntArray, Base.IntArray) =
      PRED(a0: Base.IntArray, a1: Base.IntArray):
        LET n = a0.length IN
        n = a1.length AND
        (EXISTS(p: ARRAY INT OF INT):
          (FORALL(i: INT): 0 <= i AND i < n => 
            0 <= p[i] AND p[i] < n AND 
            a0.value[i] = a1.value[p[i]]) AND
          (FORALL(j: INT): 0 <= j AND j < n => 
            (EXISTS(i: INT): 0 <= i AND i < n AND p[i] = j)));
  }
@*/
public class DutchNationalFlag
{
  public static void main(String[] args)
  {
    int[] flag = new int[5];
    flag[0] = 2;
    flag[1] = 1;
    flag[2] = 0;
    flag[3] = 1;
    flag[4] = 0;
    partition(flag);
    // for (int i=0; i<5; i++) System.out.println(flag[i]);
  }

  public static void partition(int[] flag)
  /*@ 
    requires 
      NOT (VAR flag).null AND
      (FORALL(k: INT): 0 <= k AND k < (VAR flag).length =>
         (VAR flag).value[k] = 0 OR
         (VAR flag).value[k] = 1 OR
         (VAR flag).value[k] = 2);
    assignable flag;
    ensures 
      NOT (VAR flag).null AND
      (VAR flag).length = (OLD flag).length AND
      (EXISTS(w, b: INT):
        0 <= w AND w <= b AND b <= (VAR flag).length AND
        (FORALL(k: INT): 0 <= k AND k < w => 
          (VAR flag).value[k] = 0) AND
        (FORALL(k: INT): w <= k AND k < w => 
          (VAR flag).value[k] = 1) AND
        (FORALL(k: INT): b <= k AND k < (VAR flag).length => 
          (VAR flag).value[k] = 2)) AND
      isPermutation(OLD flag, VAR flag);
  @*/
  {
    int n = flag.length;
    int u = 0;
    int w = n;
    int b = n;
    while (u < w) /*@
      invariant
        NOT (VAR flag).null AND
        (FORALL(k: INT): 0 <= k AND k < (VAR flag).length =>
           (VAR flag).value[k] = 0 OR
           (VAR flag).value[k] = 1 OR
           (VAR flag).value[k] = 2) AND
        (VAR flag).length = (OLD flag).length AND
        0 <= VAR u AND VAR u <= VAR w AND VAR w <= VAR b AND VAR b <= (VAR flag).length AND
        (FORALL(k: INT): 0 <= k AND k < VAR u => 
          (VAR flag).value[k] = 0) AND
        (FORALL(k: INT): VAR w <= k AND k < VAR b => 
          (VAR flag).value[k] = 1) AND
        (FORALL(k: INT): VAR b <= k AND k < (VAR flag).length => 
          (VAR flag).value[k] = 2) AND
        isPermutation(OLD flag, VAR flag);
      decreases VAR w-VAR u;
    @*/
    {
      int bead = flag[w-1];
      if (bead == 0)
      {
        swap(flag, w-1, u);
        u = u+1;
      }
      else if (bead == 1)
        w = w-1;
      else
      {
        swap(flag, w-1, b-1);
        w = w-1;
        b = b-1;
      }
    }
  }

  public static void swap(int[] a, int i, int j)
  /*@
      requires NOT (VAR a).null AND
               0 <= VAR i AND VAR i < (VAR a).length AND
               0 <= VAR j AND VAR j < (VAR a).length;
      assignable a;
      ensures  NOT (VAR a).null AND
               (VAR a).length = (OLD a).length AND
               (VAR a).value[VAR i] = (OLD a).value[VAR j] AND
               (VAR a).value[VAR j] = (OLD a).value[VAR i] AND
               (FORALL(k:INT): 0 <= k AND k < (VAR a).length AND
                  k /= VAR i AND k /= VAR j =>
                    (VAR a).value[k] = (OLD a).value[k]);
  @*/
  {
    int tmp = a[i];
    a[i] = a[j];
    a[j] = tmp;
  }
}



